#ifndef _H_E55F0D1E931DEEA49B874A0336E25809_FuseReport__H_
#define _H_E55F0D1E931DEEA49B874A0336E25809_FuseReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_pdu_msgs/msg/dds_opensplice/FuseStatus_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  FuseReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet grid_address_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_1_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_2_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_3_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_4_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_5_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_6_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_7_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_8_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_9_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_10_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_11_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_12_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_13_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_14_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_15_;
                ::raptor_pdu_msgs::msg::dds_::FuseStatus_ fuse_16_;
            };

            typedef DDS_DCPSStruct_var<FuseReport_> FuseReport__var;
            typedef DDS_DCPSStruct_out < FuseReport_> FuseReport__out;

        }

    }

}

#endif /* _H_E55F0D1E931DEEA49B874A0336E25809_FuseReport__H_ */
