#ifndef _H_E55F0D1E931DEEA49B874A0336E25809_FuseReport_DCPS_H_
#define _H_E55F0D1E931DEEA49B874A0336E25809_FuseReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FuseReport_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class FuseReport_TypeSupportInterface;

            typedef FuseReport_TypeSupportInterface * FuseReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FuseReport_TypeSupportInterface> FuseReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FuseReport_TypeSupportInterface> FuseReport_TypeSupportInterface_out;


            class FuseReport_DataWriter;

            typedef FuseReport_DataWriter * FuseReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FuseReport_DataWriter> FuseReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < FuseReport_DataWriter> FuseReport_DataWriter_out;


            class FuseReport_DataReader;

            typedef FuseReport_DataReader * FuseReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FuseReport_DataReader> FuseReport_DataReader_var;
            typedef DDS_DCPSInterface_out < FuseReport_DataReader> FuseReport_DataReader_out;


            class FuseReport_DataReaderView;

            typedef FuseReport_DataReaderView * FuseReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FuseReport_DataReaderView> FuseReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FuseReport_DataReaderView> FuseReport_DataReaderView_out;

            struct FuseReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FuseReport_, struct FuseReport_Seq_uniq_> FuseReport_Seq;
            typedef DDS_DCPSSequence_var < FuseReport_Seq> FuseReport_Seq_var;
            typedef DDS_DCPSSequence_out < FuseReport_Seq> FuseReport_Seq_out;

            class  FuseReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FuseReport_TypeSupportInterface_ptr _ptr_type;
                typedef FuseReport_TypeSupportInterface_var _var_type;

                static FuseReport_TypeSupportInterface_ptr _duplicate (FuseReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FuseReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FuseReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FuseReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FuseReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FuseReport_TypeSupportInterface () {};
                ~FuseReport_TypeSupportInterface () {};
            private:
                FuseReport_TypeSupportInterface (const FuseReport_TypeSupportInterface &);
                FuseReport_TypeSupportInterface & operator = (const FuseReport_TypeSupportInterface &);
            };

            class  FuseReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FuseReport_DataWriter_ptr _ptr_type;
                typedef FuseReport_DataWriter_var _var_type;

                static FuseReport_DataWriter_ptr _duplicate (FuseReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FuseReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FuseReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FuseReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FuseReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FuseReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FuseReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FuseReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FuseReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FuseReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FuseReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FuseReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FuseReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FuseReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FuseReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FuseReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FuseReport_& instance_data) = 0;

            protected:
                FuseReport_DataWriter () {};
                ~FuseReport_DataWriter () {};
            private:
                FuseReport_DataWriter (const FuseReport_DataWriter &);
                FuseReport_DataWriter & operator = (const FuseReport_DataWriter &);
            };

            class  FuseReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FuseReport_DataReader_ptr _ptr_type;
                typedef FuseReport_DataReader_var _var_type;

                static FuseReport_DataReader_ptr _duplicate (FuseReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FuseReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FuseReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FuseReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FuseReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FuseReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FuseReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FuseReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FuseReport_& instance) = 0;

            protected:
                FuseReport_DataReader () {};
                ~FuseReport_DataReader () {};
            private:
                FuseReport_DataReader (const FuseReport_DataReader &);
                FuseReport_DataReader & operator = (const FuseReport_DataReader &);
            };

            class  FuseReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FuseReport_DataReaderView_ptr _ptr_type;
                typedef FuseReport_DataReaderView_var _var_type;

                static FuseReport_DataReaderView_ptr _duplicate (FuseReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FuseReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FuseReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FuseReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FuseReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FuseReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FuseReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FuseReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FuseReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FuseReport_& instance) = 0;

            protected:
                FuseReport_DataReaderView () {};
                ~FuseReport_DataReaderView () {};
            private:
                FuseReport_DataReaderView (const FuseReport_DataReaderView &);
                FuseReport_DataReaderView & operator = (const FuseReport_DataReaderView &);
            };
        }

    }

}

#endif
