#ifndef _H_AEA3B9EDE2684F8B7A4AE515C25C5B2D_FuseStatus__H_
#define _H_AEA3B9EDE2684F8B7A4AE515C25C5B2D_FuseStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace FuseStatus_Constants
            {
                const ::DDS::Octet NO_FAULT_ = 0;

                const ::DDS::Octet BLOWN_ = 1;

                const ::DDS::Octet NOT_POWERED_ = 2;

                const ::DDS::Octet NOT_USED_ = 3;

            }

            struct  FuseStatus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet value_;
            };

            typedef DDS_DCPSStruct_var<FuseStatus_> FuseStatus__var;
            typedef DDS_DCPSStruct_out < FuseStatus_> FuseStatus__out;

        }

    }

}

#endif /* _H_AEA3B9EDE2684F8B7A4AE515C25C5B2D_FuseStatus__H_ */
