#ifndef _H_AEA3B9EDE2684F8B7A4AE515C25C5B2D_FuseStatus_DCPS_H_
#define _H_AEA3B9EDE2684F8B7A4AE515C25C5B2D_FuseStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FuseStatus_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class FuseStatus_TypeSupportInterface;

            typedef FuseStatus_TypeSupportInterface * FuseStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FuseStatus_TypeSupportInterface> FuseStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FuseStatus_TypeSupportInterface> FuseStatus_TypeSupportInterface_out;


            class FuseStatus_DataWriter;

            typedef FuseStatus_DataWriter * FuseStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FuseStatus_DataWriter> FuseStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < FuseStatus_DataWriter> FuseStatus_DataWriter_out;


            class FuseStatus_DataReader;

            typedef FuseStatus_DataReader * FuseStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FuseStatus_DataReader> FuseStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < FuseStatus_DataReader> FuseStatus_DataReader_out;


            class FuseStatus_DataReaderView;

            typedef FuseStatus_DataReaderView * FuseStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FuseStatus_DataReaderView> FuseStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FuseStatus_DataReaderView> FuseStatus_DataReaderView_out;

            struct FuseStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FuseStatus_, struct FuseStatus_Seq_uniq_> FuseStatus_Seq;
            typedef DDS_DCPSSequence_var < FuseStatus_Seq> FuseStatus_Seq_var;
            typedef DDS_DCPSSequence_out < FuseStatus_Seq> FuseStatus_Seq_out;

            class  FuseStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FuseStatus_TypeSupportInterface_ptr _ptr_type;
                typedef FuseStatus_TypeSupportInterface_var _var_type;

                static FuseStatus_TypeSupportInterface_ptr _duplicate (FuseStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FuseStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FuseStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FuseStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FuseStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FuseStatus_TypeSupportInterface () {};
                ~FuseStatus_TypeSupportInterface () {};
            private:
                FuseStatus_TypeSupportInterface (const FuseStatus_TypeSupportInterface &);
                FuseStatus_TypeSupportInterface & operator = (const FuseStatus_TypeSupportInterface &);
            };

            class  FuseStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FuseStatus_DataWriter_ptr _ptr_type;
                typedef FuseStatus_DataWriter_var _var_type;

                static FuseStatus_DataWriter_ptr _duplicate (FuseStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FuseStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FuseStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FuseStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FuseStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FuseStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FuseStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FuseStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FuseStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FuseStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FuseStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FuseStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FuseStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FuseStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FuseStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FuseStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FuseStatus_& instance_data) = 0;

            protected:
                FuseStatus_DataWriter () {};
                ~FuseStatus_DataWriter () {};
            private:
                FuseStatus_DataWriter (const FuseStatus_DataWriter &);
                FuseStatus_DataWriter & operator = (const FuseStatus_DataWriter &);
            };

            class  FuseStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FuseStatus_DataReader_ptr _ptr_type;
                typedef FuseStatus_DataReader_var _var_type;

                static FuseStatus_DataReader_ptr _duplicate (FuseStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FuseStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FuseStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FuseStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FuseStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FuseStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FuseStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FuseStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FuseStatus_& instance) = 0;

            protected:
                FuseStatus_DataReader () {};
                ~FuseStatus_DataReader () {};
            private:
                FuseStatus_DataReader (const FuseStatus_DataReader &);
                FuseStatus_DataReader & operator = (const FuseStatus_DataReader &);
            };

            class  FuseStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FuseStatus_DataReaderView_ptr _ptr_type;
                typedef FuseStatus_DataReaderView_var _var_type;

                static FuseStatus_DataReaderView_ptr _duplicate (FuseStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FuseStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FuseStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FuseStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FuseStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FuseStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FuseStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FuseStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FuseStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FuseStatus_& instance) = 0;

            protected:
                FuseStatus_DataReaderView () {};
                ~FuseStatus_DataReaderView () {};
            private:
                FuseStatus_DataReaderView (const FuseStatus_DataReaderView &);
                FuseStatus_DataReaderView & operator = (const FuseStatus_DataReaderView &);
            };
        }

    }

}

#endif
