#ifndef _H_D5FE41AE86CEAD9C700CECED0DB1B6DF_RelayCommand_DCPS_H_
#define _H_D5FE41AE86CEAD9C700CECED0DB1B6DF_RelayCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RelayCommand_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RelayCommand_TypeSupportInterface;

            typedef RelayCommand_TypeSupportInterface * RelayCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RelayCommand_TypeSupportInterface> RelayCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RelayCommand_TypeSupportInterface> RelayCommand_TypeSupportInterface_out;


            class RelayCommand_DataWriter;

            typedef RelayCommand_DataWriter * RelayCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RelayCommand_DataWriter> RelayCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < RelayCommand_DataWriter> RelayCommand_DataWriter_out;


            class RelayCommand_DataReader;

            typedef RelayCommand_DataReader * RelayCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RelayCommand_DataReader> RelayCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < RelayCommand_DataReader> RelayCommand_DataReader_out;


            class RelayCommand_DataReaderView;

            typedef RelayCommand_DataReaderView * RelayCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RelayCommand_DataReaderView> RelayCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RelayCommand_DataReaderView> RelayCommand_DataReaderView_out;

            struct RelayCommand_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RelayCommand_, struct RelayCommand_Seq_uniq_> RelayCommand_Seq;
            typedef DDS_DCPSSequence_var < RelayCommand_Seq> RelayCommand_Seq_var;
            typedef DDS_DCPSSequence_out < RelayCommand_Seq> RelayCommand_Seq_out;

            class  RelayCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RelayCommand_TypeSupportInterface_ptr _ptr_type;
                typedef RelayCommand_TypeSupportInterface_var _var_type;

                static RelayCommand_TypeSupportInterface_ptr _duplicate (RelayCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RelayCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RelayCommand_TypeSupportInterface () {};
                ~RelayCommand_TypeSupportInterface () {};
            private:
                RelayCommand_TypeSupportInterface (const RelayCommand_TypeSupportInterface &);
                RelayCommand_TypeSupportInterface & operator = (const RelayCommand_TypeSupportInterface &);
            };

            class  RelayCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RelayCommand_DataWriter_ptr _ptr_type;
                typedef RelayCommand_DataWriter_var _var_type;

                static RelayCommand_DataWriter_ptr _duplicate (RelayCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RelayCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RelayCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RelayCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RelayCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RelayCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RelayCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RelayCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RelayCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RelayCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RelayCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RelayCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RelayCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayCommand_& instance_data) = 0;

            protected:
                RelayCommand_DataWriter () {};
                ~RelayCommand_DataWriter () {};
            private:
                RelayCommand_DataWriter (const RelayCommand_DataWriter &);
                RelayCommand_DataWriter & operator = (const RelayCommand_DataWriter &);
            };

            class  RelayCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RelayCommand_DataReader_ptr _ptr_type;
                typedef RelayCommand_DataReader_var _var_type;

                static RelayCommand_DataReader_ptr _duplicate (RelayCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RelayCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RelayCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RelayCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RelayCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayCommand_& instance) = 0;

            protected:
                RelayCommand_DataReader () {};
                ~RelayCommand_DataReader () {};
            private:
                RelayCommand_DataReader (const RelayCommand_DataReader &);
                RelayCommand_DataReader & operator = (const RelayCommand_DataReader &);
            };

            class  RelayCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RelayCommand_DataReaderView_ptr _ptr_type;
                typedef RelayCommand_DataReaderView_var _var_type;

                static RelayCommand_DataReaderView_ptr _duplicate (RelayCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RelayCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RelayCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RelayCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RelayCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RelayCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayCommand_& instance) = 0;

            protected:
                RelayCommand_DataReaderView () {};
                ~RelayCommand_DataReaderView () {};
            private:
                RelayCommand_DataReaderView (const RelayCommand_DataReaderView &);
                RelayCommand_DataReaderView & operator = (const RelayCommand_DataReaderView &);
            };
        }

    }

}

#endif
