#ifndef _H_14CD0A47763E81EC932CA203E85C784C_RelayReport__H_
#define _H_14CD0A47763E81EC932CA203E85C784C_RelayReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_pdu_msgs/msg/dds_opensplice/RelayStatus_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  RelayReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet grid_address_;
                ::raptor_pdu_msgs::msg::dds_::RelayStatus_ relay_1_;
                ::raptor_pdu_msgs::msg::dds_::RelayStatus_ relay_2_;
                ::raptor_pdu_msgs::msg::dds_::RelayStatus_ relay_3_;
                ::raptor_pdu_msgs::msg::dds_::RelayStatus_ relay_4_;
                ::raptor_pdu_msgs::msg::dds_::RelayStatus_ relay_5_;
                ::raptor_pdu_msgs::msg::dds_::RelayStatus_ relay_6_;
                ::raptor_pdu_msgs::msg::dds_::RelayStatus_ relay_7_;
                ::raptor_pdu_msgs::msg::dds_::RelayStatus_ relay_8_;
            };

            typedef DDS_DCPSStruct_var<RelayReport_> RelayReport__var;
            typedef DDS_DCPSStruct_out < RelayReport_> RelayReport__out;

        }

    }

}

#endif /* _H_14CD0A47763E81EC932CA203E85C784C_RelayReport__H_ */
