#ifndef _H_C8B8D0308BB9098F45D1EDE4453DD000_RelayState__H_
#define _H_C8B8D0308BB9098F45D1EDE4453DD000_RelayState__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace RelayState_Constants
            {
                const ::DDS::Octet RELAY_OFF_ = 0;

                const ::DDS::Octet RELAY_ON_ = 1;

                const ::DDS::Octet MAINTAIN_STATE_ = 2;

            }

            struct  RelayState_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet value_;
            };

            typedef DDS_DCPSStruct_var<RelayState_> RelayState__var;
            typedef DDS_DCPSStruct_out < RelayState_> RelayState__out;

        }

    }

}

#endif /* _H_C8B8D0308BB9098F45D1EDE4453DD000_RelayState__H_ */
