#ifndef _H_C8B8D0308BB9098F45D1EDE4453DD000_RelayState_DCPS_H_
#define _H_C8B8D0308BB9098F45D1EDE4453DD000_RelayState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RelayState_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RelayState_TypeSupportInterface;

            typedef RelayState_TypeSupportInterface * RelayState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RelayState_TypeSupportInterface> RelayState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RelayState_TypeSupportInterface> RelayState_TypeSupportInterface_out;


            class RelayState_DataWriter;

            typedef RelayState_DataWriter * RelayState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RelayState_DataWriter> RelayState_DataWriter_var;
            typedef DDS_DCPSInterface_out < RelayState_DataWriter> RelayState_DataWriter_out;


            class RelayState_DataReader;

            typedef RelayState_DataReader * RelayState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RelayState_DataReader> RelayState_DataReader_var;
            typedef DDS_DCPSInterface_out < RelayState_DataReader> RelayState_DataReader_out;


            class RelayState_DataReaderView;

            typedef RelayState_DataReaderView * RelayState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RelayState_DataReaderView> RelayState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RelayState_DataReaderView> RelayState_DataReaderView_out;

            struct RelayState_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RelayState_, struct RelayState_Seq_uniq_> RelayState_Seq;
            typedef DDS_DCPSSequence_var < RelayState_Seq> RelayState_Seq_var;
            typedef DDS_DCPSSequence_out < RelayState_Seq> RelayState_Seq_out;

            class  RelayState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RelayState_TypeSupportInterface_ptr _ptr_type;
                typedef RelayState_TypeSupportInterface_var _var_type;

                static RelayState_TypeSupportInterface_ptr _duplicate (RelayState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RelayState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RelayState_TypeSupportInterface () {};
                ~RelayState_TypeSupportInterface () {};
            private:
                RelayState_TypeSupportInterface (const RelayState_TypeSupportInterface &);
                RelayState_TypeSupportInterface & operator = (const RelayState_TypeSupportInterface &);
            };

            class  RelayState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RelayState_DataWriter_ptr _ptr_type;
                typedef RelayState_DataWriter_var _var_type;

                static RelayState_DataWriter_ptr _duplicate (RelayState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RelayState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RelayState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RelayState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RelayState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RelayState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RelayState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RelayState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RelayState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RelayState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RelayState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RelayState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RelayState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayState_& instance_data) = 0;

            protected:
                RelayState_DataWriter () {};
                ~RelayState_DataWriter () {};
            private:
                RelayState_DataWriter (const RelayState_DataWriter &);
                RelayState_DataWriter & operator = (const RelayState_DataWriter &);
            };

            class  RelayState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RelayState_DataReader_ptr _ptr_type;
                typedef RelayState_DataReader_var _var_type;

                static RelayState_DataReader_ptr _duplicate (RelayState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RelayState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RelayState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RelayState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RelayState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayState_& instance) = 0;

            protected:
                RelayState_DataReader () {};
                ~RelayState_DataReader () {};
            private:
                RelayState_DataReader (const RelayState_DataReader &);
                RelayState_DataReader & operator = (const RelayState_DataReader &);
            };

            class  RelayState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RelayState_DataReaderView_ptr _ptr_type;
                typedef RelayState_DataReaderView_var _var_type;

                static RelayState_DataReaderView_ptr _duplicate (RelayState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RelayState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RelayState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RelayState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RelayState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RelayState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayState_& instance) = 0;

            protected:
                RelayState_DataReaderView () {};
                ~RelayState_DataReaderView () {};
            private:
                RelayState_DataReaderView (const RelayState_DataReaderView &);
                RelayState_DataReaderView & operator = (const RelayState_DataReaderView &);
            };
        }

    }

}

#endif
