#ifndef _H_BBF2714BBF941A07830B0EC95331E58C_RelayStatus__H_
#define _H_BBF2714BBF941A07830B0EC95331E58C_RelayStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace RelayStatus_Constants
            {
                const ::DDS::Octet OK_ = 0;

                const ::DDS::Octet RELAY_COIL_OPEN_ = 1;

                const ::DDS::Octet RELAY_COIL_SHORTED_ = 2;

                const ::DDS::Octet NORM_OPEN_RELAY_OPEN_ = 3;

                const ::DDS::Octet NORM_CLOSED_RELAY_OPEN_ = 4;

                const ::DDS::Octet COIL_NOT_POWERED_ = 5;

                const ::DDS::Octet NORM_OPEN_RELAY_SHORTED_ = 6;

                const ::DDS::Octet NORM_CLOSED_RELAY_SHORTED_ = 7;

                const ::DDS::Octet RESERVED_01_ = 8;

                const ::DDS::Octet RESERVED_02_ = 9;

                const ::DDS::Octet RESERVED_03_ = 10;

                const ::DDS::Octet HIGH_SIDE_FAULT_ = 11;

                const ::DDS::Octet HIGH_SIDE_OPEN_LOAD_ = 12;

                const ::DDS::Octet HIGH_SIDE_OVER_VOLTAGE_ = 13;

                const ::DDS::Octet RESERVED_04_ = 14;

                const ::DDS::Octet RELAY_LOCATION_NOT_USED_ = 15;

            }

            struct  RelayStatus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet value_;
            };

            typedef DDS_DCPSStruct_var<RelayStatus_> RelayStatus__var;
            typedef DDS_DCPSStruct_out < RelayStatus_> RelayStatus__out;

        }

    }

}

#endif /* _H_BBF2714BBF941A07830B0EC95331E58C_RelayStatus__H_ */
