#ifndef _H_BBF2714BBF941A07830B0EC95331E58C_RelayStatus_DCPS_H_
#define _H_BBF2714BBF941A07830B0EC95331E58C_RelayStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RelayStatus_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RelayStatus_TypeSupportInterface;

            typedef RelayStatus_TypeSupportInterface * RelayStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RelayStatus_TypeSupportInterface> RelayStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RelayStatus_TypeSupportInterface> RelayStatus_TypeSupportInterface_out;


            class RelayStatus_DataWriter;

            typedef RelayStatus_DataWriter * RelayStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RelayStatus_DataWriter> RelayStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < RelayStatus_DataWriter> RelayStatus_DataWriter_out;


            class RelayStatus_DataReader;

            typedef RelayStatus_DataReader * RelayStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RelayStatus_DataReader> RelayStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < RelayStatus_DataReader> RelayStatus_DataReader_out;


            class RelayStatus_DataReaderView;

            typedef RelayStatus_DataReaderView * RelayStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RelayStatus_DataReaderView> RelayStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RelayStatus_DataReaderView> RelayStatus_DataReaderView_out;

            struct RelayStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RelayStatus_, struct RelayStatus_Seq_uniq_> RelayStatus_Seq;
            typedef DDS_DCPSSequence_var < RelayStatus_Seq> RelayStatus_Seq_var;
            typedef DDS_DCPSSequence_out < RelayStatus_Seq> RelayStatus_Seq_out;

            class  RelayStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RelayStatus_TypeSupportInterface_ptr _ptr_type;
                typedef RelayStatus_TypeSupportInterface_var _var_type;

                static RelayStatus_TypeSupportInterface_ptr _duplicate (RelayStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RelayStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RelayStatus_TypeSupportInterface () {};
                ~RelayStatus_TypeSupportInterface () {};
            private:
                RelayStatus_TypeSupportInterface (const RelayStatus_TypeSupportInterface &);
                RelayStatus_TypeSupportInterface & operator = (const RelayStatus_TypeSupportInterface &);
            };

            class  RelayStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RelayStatus_DataWriter_ptr _ptr_type;
                typedef RelayStatus_DataWriter_var _var_type;

                static RelayStatus_DataWriter_ptr _duplicate (RelayStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RelayStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RelayStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RelayStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RelayStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RelayStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RelayStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RelayStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RelayStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RelayStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RelayStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RelayStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RelayStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayStatus_& instance_data) = 0;

            protected:
                RelayStatus_DataWriter () {};
                ~RelayStatus_DataWriter () {};
            private:
                RelayStatus_DataWriter (const RelayStatus_DataWriter &);
                RelayStatus_DataWriter & operator = (const RelayStatus_DataWriter &);
            };

            class  RelayStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RelayStatus_DataReader_ptr _ptr_type;
                typedef RelayStatus_DataReader_var _var_type;

                static RelayStatus_DataReader_ptr _duplicate (RelayStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RelayStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RelayStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RelayStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RelayStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayStatus_& instance) = 0;

            protected:
                RelayStatus_DataReader () {};
                ~RelayStatus_DataReader () {};
            private:
                RelayStatus_DataReader (const RelayStatus_DataReader &);
                RelayStatus_DataReader & operator = (const RelayStatus_DataReader &);
            };

            class  RelayStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RelayStatus_DataReaderView_ptr _ptr_type;
                typedef RelayStatus_DataReaderView_var _var_type;

                static RelayStatus_DataReaderView_ptr _duplicate (RelayStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RelayStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RelayStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RelayStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RelayStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RelayStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayStatus_& instance) = 0;

            protected:
                RelayStatus_DataReaderView () {};
                ~RelayStatus_DataReaderView () {};
            private:
                RelayStatus_DataReaderView (const RelayStatus_DataReaderView &);
                RelayStatus_DataReaderView & operator = (const RelayStatus_DataReaderView &);
            };
        }

    }

}

#endif
