// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from raptor_pdu_msgs:msg/RelayReport.idl
// generated code does not contain a copyright notice

#ifndef RAPTOR_PDU_MSGS__MSG__RELAY_REPORT__FUNCTIONS_H_
#define RAPTOR_PDU_MSGS__MSG__RELAY_REPORT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "raptor_pdu_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "raptor_pdu_msgs/msg/relay_report__struct.h"

/// Initialize msg/RelayReport message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * raptor_pdu_msgs__msg__RelayReport
 * )) before or use
 * raptor_pdu_msgs__msg__RelayReport__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_raptor_pdu_msgs
bool
raptor_pdu_msgs__msg__RelayReport__init(raptor_pdu_msgs__msg__RelayReport * msg);

/// Finalize msg/RelayReport message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_raptor_pdu_msgs
void
raptor_pdu_msgs__msg__RelayReport__fini(raptor_pdu_msgs__msg__RelayReport * msg);

/// Create msg/RelayReport message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * raptor_pdu_msgs__msg__RelayReport__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_raptor_pdu_msgs
raptor_pdu_msgs__msg__RelayReport *
raptor_pdu_msgs__msg__RelayReport__create();

/// Destroy msg/RelayReport message.
/**
 * It calls
 * raptor_pdu_msgs__msg__RelayReport__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_raptor_pdu_msgs
void
raptor_pdu_msgs__msg__RelayReport__destroy(raptor_pdu_msgs__msg__RelayReport * msg);


/// Initialize array of msg/RelayReport messages.
/**
 * It allocates the memory for the number of elements and calls
 * raptor_pdu_msgs__msg__RelayReport__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_raptor_pdu_msgs
bool
raptor_pdu_msgs__msg__RelayReport__Sequence__init(raptor_pdu_msgs__msg__RelayReport__Sequence * array, size_t size);

/// Finalize array of msg/RelayReport messages.
/**
 * It calls
 * raptor_pdu_msgs__msg__RelayReport__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_raptor_pdu_msgs
void
raptor_pdu_msgs__msg__RelayReport__Sequence__fini(raptor_pdu_msgs__msg__RelayReport__Sequence * array);

/// Create array of msg/RelayReport messages.
/**
 * It allocates the memory for the array and calls
 * raptor_pdu_msgs__msg__RelayReport__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_raptor_pdu_msgs
raptor_pdu_msgs__msg__RelayReport__Sequence *
raptor_pdu_msgs__msg__RelayReport__Sequence__create(size_t size);

/// Destroy array of msg/RelayReport messages.
/**
 * It calls
 * raptor_pdu_msgs__msg__RelayReport__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_raptor_pdu_msgs
void
raptor_pdu_msgs__msg__RelayReport__Sequence__destroy(raptor_pdu_msgs__msg__RelayReport__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // RAPTOR_PDU_MSGS__MSG__RELAY_REPORT__FUNCTIONS_H_
