#ifndef _H_14CD0A47763E81EC932CA203E85C784C_RelayReport_DCPS_H_
#define _H_14CD0A47763E81EC932CA203E85C784C_RelayReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RelayReport_.h"


namespace raptor_pdu_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RelayReport_TypeSupportInterface;

            typedef RelayReport_TypeSupportInterface * RelayReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RelayReport_TypeSupportInterface> RelayReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RelayReport_TypeSupportInterface> RelayReport_TypeSupportInterface_out;


            class RelayReport_DataWriter;

            typedef RelayReport_DataWriter * RelayReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RelayReport_DataWriter> RelayReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < RelayReport_DataWriter> RelayReport_DataWriter_out;


            class RelayReport_DataReader;

            typedef RelayReport_DataReader * RelayReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RelayReport_DataReader> RelayReport_DataReader_var;
            typedef DDS_DCPSInterface_out < RelayReport_DataReader> RelayReport_DataReader_out;


            class RelayReport_DataReaderView;

            typedef RelayReport_DataReaderView * RelayReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RelayReport_DataReaderView> RelayReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RelayReport_DataReaderView> RelayReport_DataReaderView_out;

            struct RelayReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RelayReport_, struct RelayReport_Seq_uniq_> RelayReport_Seq;
            typedef DDS_DCPSSequence_var < RelayReport_Seq> RelayReport_Seq_var;
            typedef DDS_DCPSSequence_out < RelayReport_Seq> RelayReport_Seq_out;

            class  RelayReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RelayReport_TypeSupportInterface_ptr _ptr_type;
                typedef RelayReport_TypeSupportInterface_var _var_type;

                static RelayReport_TypeSupportInterface_ptr _duplicate (RelayReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RelayReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RelayReport_TypeSupportInterface () {};
                ~RelayReport_TypeSupportInterface () {};
            private:
                RelayReport_TypeSupportInterface (const RelayReport_TypeSupportInterface &);
                RelayReport_TypeSupportInterface & operator = (const RelayReport_TypeSupportInterface &);
            };

            class  RelayReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RelayReport_DataWriter_ptr _ptr_type;
                typedef RelayReport_DataWriter_var _var_type;

                static RelayReport_DataWriter_ptr _duplicate (RelayReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RelayReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RelayReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RelayReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RelayReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RelayReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RelayReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RelayReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RelayReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RelayReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RelayReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RelayReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RelayReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayReport_& instance_data) = 0;

            protected:
                RelayReport_DataWriter () {};
                ~RelayReport_DataWriter () {};
            private:
                RelayReport_DataWriter (const RelayReport_DataWriter &);
                RelayReport_DataWriter & operator = (const RelayReport_DataWriter &);
            };

            class  RelayReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RelayReport_DataReader_ptr _ptr_type;
                typedef RelayReport_DataReader_var _var_type;

                static RelayReport_DataReader_ptr _duplicate (RelayReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RelayReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RelayReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RelayReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RelayReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayReport_& instance) = 0;

            protected:
                RelayReport_DataReader () {};
                ~RelayReport_DataReader () {};
            private:
                RelayReport_DataReader (const RelayReport_DataReader &);
                RelayReport_DataReader & operator = (const RelayReport_DataReader &);
            };

            class  RelayReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RelayReport_DataReaderView_ptr _ptr_type;
                typedef RelayReport_DataReaderView_var _var_type;

                static RelayReport_DataReaderView_ptr _duplicate (RelayReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RelayReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RelayReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RelayReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RelayReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RelayReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RelayReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RelayReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RelayReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RelayReport_& instance) = 0;

            protected:
                RelayReport_DataReaderView () {};
                ~RelayReport_DataReaderView () {};
            private:
                RelayReport_DataReaderView (const RelayReport_DataReaderView &);
                RelayReport_DataReaderView & operator = (const RelayReport_DataReaderView &);
            };
        }

    }

}

#endif
